/* tmne1d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static double c_b14 = 1.;

int main(void)
{
    /* Initialized data */
    static double fe = 1e-7;
    static double xe[2] = { 1e-8,1e-8 };
    static double ge[2] = { .001,.001 };
    static float up[9] = { 5.f,.7f,.3f,500.f,600.f,0.f,0.f,10.f,1.f };
    static int i0[2] = { 1,1 };
    static int n = 2;
    static double x[2] = { -3.,1. };

    /* Local variables */
    static int ierr;
    extern int mne1d_c(double *, double *, U_fp, double *, double *, int *,
                       int *, int *, double *, U_fp, float *, double *,
                       double *);
    static double f, g[2];
    extern int conus_c();
    static double rm[4];
    extern int subcon_c();

    mne1d_c(&f, &fe, (U_fp)conus_c, g, ge, &ierr, i0, &n, rm, (U_fp)subcon_c,
            up, x, xe);

    printf("\n %24.14e %24.14e \n", x[0], x[1]);
    printf("\n %24.14e \n", f);
    printf("\n %24.14e %24.14e \n", g[0], g[1]);
    printf("\n %5i \n", ierr);
    printf("\n %9.3f \n", up[4]);
    return 0;
} /* main */

int conus_c(double *x, double *f, double *fe)
{
    /* Initialized data */
    static double a[2] = { 1.,4. };
    static double b[2] = { -2.,6. };

    static int i__;
    static double arg;

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *f = 0.;
    for (i__ = 1; i__ <= 2; ++i__) {
        arg = a[i__ - 1] * x[i__] - b[i__ - 1];
        *f += abs(arg);
/* L1: */
    }
    return 0;
} /* conus_c */

int subcon_c(double *x, double *g, double *ge, int *i0)
{
    /* Initialized data */
    static double a[2] = { 1.,4. };
    static double b[2] = { -2.,6. };

    /* Builtin functions */
    double d_sign(double *, double *);

    /* Local variables */
    static int i__;
    static double arg;

/*  BCET CYPAEHT - CONUS */
    /* Parameter adjustments */
    --i0;
    --ge;
    --g;
    --x;

    /* Function Body */
    for (i__ = 1; i__ <= 2; ++i__) {
        if (i0[i__] == 0) {
            goto L2;
        }
        arg = a[i__ - 1] * x[i__] - b[i__ - 1];
        g[i__] = d_sign(&c_b14, &arg) * a[i__ - 1];
        goto L1;
L2:
        g[i__] = 0.;
L1:
        ;
    }
    return 0;
} /* subcon_c */
